KeyedPooledObjectFactory (Apache Tomcat 9.0.37 API Documentation)

org.apache.tomcat.dbcp.pool2

## Interface KeyedPooledObjectFactory<K,V>

- Type Parameters:
    `K` - The type of keys managed by this factory.
    `V` - Type of element managed by this factory.
  All Known Implementing Classes:
    BaseKeyedPooledObjectFactory, PoolingConnection

      public interface KeyedPooledObjectFactory<K,V>

  An interface defining life-cycle methods for instances to be served by a `KeyedObjectPool`.

  By contract, when an `KeyedObjectPool` delegates to a `KeyedPooledObjectFactory`,

  1. `makeObject(K)` is called whenever a new instance is needed.
  2. `activateObject(K, org.apache.tomcat.dbcp.pool2.PooledObject<V>)` is invoked on every instance that has been `passivated` before it is `borrowed` from the pool.
  3. `validateObject(K, org.apache.tomcat.dbcp.pool2.PooledObject<V>)` may be invoked on `activated` instances to make sure they can be `borrowed` from the pool. `validateObject` may also be used to test an instance being `returned` to the pool before it is `passivated`. It will only be invoked on an activated instance.
  4. `passivateObject` is invoked on every instance when it is returned to the pool.
  5. `destroyObject` is invoked on every instance when it is being "dropped" from the pool (whether due to the response from `validateObject`, or for reasons specific to the pool implementation.) There is no guarantee that the instance being destroyed will be considered active, passive or in a generally consistent state.
  `KeyedPooledObjectFactory` must be thread-safe. The only promise an `KeyedObjectPool` makes is that the same instance of an object will not be passed to more than one method of a `KeyedPoolableObjectFactory` at a time.

  While clients of a `KeyedObjectPool` borrow and return instances of the underlying value type V, the factory methods act on instances of `PooledObject<V>`. These are the object wrappers that pools use to track and maintain state informations about the objects that they manage.

  Since:
    2.0
  See Also:
    `KeyedObjectPool`, `BaseKeyedPooledObjectFactory`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `activateObject(K key, PooledObject<V> p)` Reinitialize an instance to be returned by the pool.
    `void` | `destroyObject(K key, PooledObject<V> p)` Destroy an instance no longer needed by the pool.
    `PooledObject<V>` | `makeObject(K key)` Create an instance that can be served by the pool and wrap it in a `PooledObject` to be managed by the pool.
    `void` | `passivateObject(K key, PooledObject<V> p)` Uninitialize an instance to be returned to the idle object pool.
    `boolean` | `validateObject(K key, PooledObject<V> p)` Ensures that the instance is safe to be returned by the pool.

- - ### Method Detail

    - #### makeObject

          PooledObject<V> makeObject(K key)
                              throws Exception

      Create an instance that can be served by the pool and wrap it in a `PooledObject` to be managed by the pool.
      Parameters:
        `key` - the key used when constructing the object
      Returns:
        a `PooledObject` wrapping an instance that can be served by the pool.
      Throws:
        `Exception` - if there is a problem creating a new instance, this will be propagated to the code requesting an object.

    - #### destroyObject

          void destroyObject(K key,
                             PooledObject<V> p)
                      throws Exception

      Destroy an instance no longer needed by the pool.

      It is important for implementations of this method to be aware that there is no guarantee about what state `obj` will be in and the implementation should be prepared to handle unexpected errors.

      Also, an implementation must take in to consideration that instances lost to the garbage collector may never be destroyed.

      Parameters:
        `key` - the key used when selecting the instance
        `p` - a `PooledObject` wrapping the instance to be destroyed
      Throws:
        `Exception` - should be avoided as it may be swallowed by the pool implementation.
      See Also:
        `validateObject(K, org.apache.tomcat.dbcp.pool2.PooledObject<V>)`, `KeyedObjectPool.invalidateObject(K, V)`

    - #### validateObject

          boolean validateObject(K key,
                                 PooledObject<V> p)

      Ensures that the instance is safe to be returned by the pool.
      Parameters:
        `key` - the key used when selecting the object
        `p` - a `PooledObject` wrapping the instance to be validated
      Returns:
        `false` if `obj` is not valid and should be dropped from the pool, `true` otherwise.

    - #### activateObject

          void activateObject(K key,
                              PooledObject<V> p)
                       throws Exception

      Reinitialize an instance to be returned by the pool.
      Parameters:
        `key` - the key used when selecting the object
        `p` - a `PooledObject` wrapping the instance to be activated
      Throws:
        `Exception` - if there is a problem activating `obj`, this exception may be swallowed by the pool.
      See Also:
        `destroyObject(K, org.apache.tomcat.dbcp.pool2.PooledObject<V>)`

    - #### passivateObject

          void passivateObject(K key,
                               PooledObject<V> p)
                        throws Exception

      Uninitialize an instance to be returned to the idle object pool.
      Parameters:
        `key` - the key used when selecting the object
        `p` - a `PooledObject` wrapping the instance to be passivated
      Throws:
        `Exception` - if there is a problem passivating `obj`, this exception may be swallowed by the pool.
      See Also:
        `destroyObject(K, org.apache.tomcat.dbcp.pool2.PooledObject<V>)`

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.